import java.awt.*;
import java.awt.event.*;
import java.net.MalformedURLException;
import java.util.*;
import com.sun.java.swing.*;
import javax.swing.*;
import javax.swing.border.*;
import java.io.*;


public class MenusInASLSigns1a extends JFrame
{
    boolean[] flg;
    
    public JMenuItem jx[];
    public JMenuItem fingerspellingMenuItems[];
    public JMenuItem typeWordsMenuItems[];
    public JMenuItem dictionariesMenuItems[];
    public ImageIcon imageIcon1[];
    public ImageIcon imageIcon2[];
    public ImageIcon imageIcon3[];
    public ImageIcon imageIcon4[];
    public JSeparator separatorArray[];
    public JSeparator separatorArray3[];
    public JSeparator separatorArray2[];
    public JSeparator separatorArray1[];
    

    public JTextArea imgDisplay;
    public int saveJxxx;//the index of the country menuItem to call IntlWordsMenus()

	public MenusInASLSigns1a(boolean flg[]) 
	{
	    this.flg = flg;
	    String language = "en";
	    String country = "US";
	    Locale currentLocale;
	    Locale setupLocale;
	    ResourceBundle messages;
	    ResourceBundle setupMessages;
	    
	    setupLocale = new Locale("Checkbox", "Countries");
	    currentLocale = new Locale("ASL", "US");//(language, country);
	    
	    messages = ResourceBundle.getBundle("MessagesBundle", currentLocale);
	    setupMessages = ResourceBundle.getBundle("MessagesBundle", setupLocale);
	    
		//
		setTitle("SignWriter 5.0");
		setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		getContentPane().setLayout(new BorderLayout());//(50,50));
		setSize(799,600);//(775,550);

        //
		ImageIcon menusVisualIcon = new ImageIcon("images/MenusHeading-UseThis.jpg");
		ImageIcon dictionaryVisualIcon1 = new ImageIcon("images/dictionaryVisual.jpg");
        JLabel dictionaryVisual1Label = new JLabel(dictionaryVisualIcon1);
		//
		ImageIcon fontsVisualIcon1 = new ImageIcon("images/Fonts-UseThis.JPG");
        JLabel overTheMenusFonts1Label = new JLabel(fontsVisualIcon1);
        //
        JLabel menusMenuLabel1 = new JLabel(menusVisualIcon);
        //visualFileMenuType1Item.setIcon(type1VisualIcon);

		saveFileDialog.setMode(FileDialog.LOAD);
		//$$ saveFileDialog.move(24,336);
		openFileDialog.setMode(FileDialog.LOAD);
		//$$ openFileDialog.move(0,336);

        JPanel1.add(JMenuBar1);
        //****getContentPane().add(JPanel1);
		//getContentPane().add("Center",JPanel1);
        //setJMenuBar(JMenuBar1);
        //JMenuBar1.move(8,312);
        
    	//icons for file menu items
    	ImageIcon newIcon        = new ImageIcon(messages.getString("fileMenuItemNew"));
	    ImageIcon openIcon      = new ImageIcon(messages.getString("fileMenuItemOpen"));
    	ImageIcon saveIcon      = new ImageIcon(messages.getString("fileMenuItemSave"));
    	ImageIcon saveAsIcon    = new ImageIcon(messages.getString("fileMenuItemSaveAs"));
    	ImageIcon printIcon     = new ImageIcon(messages.getString("fileMenuItemPrint"));
    	ImageIcon exitIcon      = new ImageIcon(messages.getString("fileMenuItemExit"));
    	
    	//icons for edit menu items
    	ImageIcon undoIcon          = new ImageIcon(messages.getString("editMenuItemUndo"));
    	ImageIcon cutIcon           = new ImageIcon(messages.getString("editMenuItemCut"));
    	ImageIcon copyIcon          = new ImageIcon(messages.getString("editMenuItemCopy"));
    	ImageIcon pasteIcon         = new ImageIcon(messages.getString("editMenuItemPaste"));
    	ImageIcon deleteIcon        = new ImageIcon(messages.getString("editMenuItemDelete"));
    	ImageIcon selectAllIcon     = new ImageIcon(messages.getString("editMenuItemSelectAll"));
    	
    	
    	////icons for type signs menu items
    	ImageIcon signsMenuItemDownColLRIcon         = new ImageIcon(messages.getString("signsMenuItemDownColL-R"));
    	ImageIcon signsMenuItemDownColRLIcon        = new ImageIcon(messages.getString("signsMenuItemDownColR-L"));
    	ImageIcon signsMenuItemAcrossLRIcon         = new ImageIcon(messages.getString("signsMenuItemAcrossL-R"));
    	ImageIcon signsMenuItemAcrossRLIcon         = new ImageIcon(messages.getString("signsMenuItemAcrossR-L"));
    	ImageIcon signsMenuItemOtherPatternsIcon    = new ImageIcon(messages.getString("signsMenuItemOtherPatterns"));
        
        //icons for fonts menu items
        ImageIcon largeFontsIcon        = new ImageIcon(messages.getString("fontsMenuItemLarge"));//	
        ImageIcon mediumFontsIcon       = new ImageIcon(messages.getString("fontsMenuItemMedium"));//	
        ImageIcon smallFontsIcon        = new ImageIcon(messages.getString("fontsMenuItemSmall"));//	
        ImageIcon boldFontsIcon         = new ImageIcon(messages.getString("fontsMenuItemBold"));//	
        ImageIcon italicFontsIcon       = new ImageIcon(messages.getString("fontsMenuItemItalic"));//	
        ImageIcon colorSymbolsFontsIcon = new ImageIcon(messages.getString("fontsMenuItemColorSymbols"));//	

    	//icons for help menu items
    	ImageIcon lessonsInSignWritingIcon  = new ImageIcon(messages.getString("helpMenuItemLessonsInSignWriting"));
    	ImageIcon lessonsInSignWriterIcon   = new ImageIcon(messages.getString("helpMenuItemLessonsInSignWriter"));
    	ImageIcon aboutSignWriterIcon       = new ImageIcon(messages.getString("helpMenuItemAboutSignWriter"));
    	ImageIcon technicalSupportIcon      = new ImageIcon(messages.getString("helpMenuItemTechnicalSupport"));
        
        //icons to head menus
        ImageIcon editIcon              = new ImageIcon(messages.getString("editMenuTitle"));//	
        ImageIcon fileIcon              = new ImageIcon(messages.getString("fileMenuTitle"));//	
        ImageIcon menusIcon             = new ImageIcon(messages.getString("menusMenuTitle"));//	
        ImageIcon signsIcon             = new ImageIcon(messages.getString("signsMenuTitle"));//	
        ImageIcon fingerspellingIcon    = new ImageIcon(messages.getString("fingerspellingMenuTitle"));//	
        ImageIcon dictionariesIcon      = new ImageIcon(messages.getString("dictionariesMenuTitle"));//	
        ImageIcon typeWordsIcon         = new ImageIcon(messages.getString("typeWordsMenuTitle"));//	
        ImageIcon fontsIcon             = new ImageIcon(messages.getString("fontsMenuTitle"));//	
        ImageIcon helpIcon              = new ImageIcon(messages.getString("helpMenuTitle"));//	
		
		
		saveFileDialog.setMode(FileDialog.SAVE);
		saveFileDialog.setTitle("Save");
		//$$ saveFileDialog.move(24,336);
		openFileDialog.setMode(FileDialog.LOAD);
		openFileDialog.setTitle("Open");
		//$$ openFileDialog.move(0,336);
		JPanel2.setLayout(new FlowLayout(FlowLayout.LEFT,10,10));
		getContentPane().add("North", JPanel2);
		JPanel2.setBounds(0,0,50,29);

		//add goToConfigButton to panel1
		goToConfigButton.setText("Setup");
		goToConfigButton.setBackground(Color.lightGray);
		//goToConfigButton.setForeground(new java.awt.Color(64,164,189));
		goToConfigButton.setForeground(new Color(64,164,189));
        JPanel1.add(goToConfigButton);
        
        //add panel1 to display
		getContentPane().add("West", JPanel1);
		
		//file menu
		fileMenu.setIcon(fileIcon);
		fileMenu.setActionCommand("File");
		fileMenu.setMnemonic((int)'1');//'F');
		JMenuBar1.add(fileMenu);
		//
		newItem.setIcon(newIcon);
		newItem.setActionCommand("New");
		//newItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_N, Event.CTRL_MASK));
		newItem.setMnemonic((int)'1');//'N');
		fileMenu.add(newItem);
		fileMenu.add(JSeparator1);
		//
		openItem.setIcon(openIcon);
		openItem.setActionCommand("Open...");
		//openItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_O, Event.CTRL_MASK));
		openItem.setMnemonic((int)'2');//'O');
		fileMenu.add(openItem);
		fileMenu.add(JSeparator2);

		//
		saveItem.setIcon(saveIcon);
		saveItem.setActionCommand("Save");
		saveItem.setMnemonic((int)'3');//'S');
	    fileMenu.add(saveItem);
		fileMenu.add(JSeparator3);

		//
		saveAsItem.setIcon(saveAsIcon);
		//saveAsItem.setText("Save As...");
		saveAsItem.setActionCommand("Save As...");
		saveAsItem.setMnemonic((int)'A');
		fileMenu.add(saveAsItem);
		fileMenu.add(JSeparator4);

		//
		printItem.setActionCommand("Print");
        printItem.setIcon(printIcon);
		saveAsItem.setMnemonic((int)'A');
		fileMenu.add(printItem);//fileMenuPrintLabel);
		fileMenu.add(JSeparator5);
		//
		exitItem.setIcon(exitIcon);
		//exitItem.setText("Exit");
		exitItem.setActionCommand("Exit");
		exitItem.setMnemonic((int)'X');
		fileMenu.add(exitItem);
		
		//editMenu
		editMenu.setIcon(editIcon);
		editMenu.setActionCommand("Edit");
		editMenu.setMnemonic((int)'2');//'E');
		JMenuBar1.add(editMenu);
		
		////editMenu - undoItem
		undoItem.setIcon(undoIcon);
		undoItem.setActionCommand("Undo");
		//pasteItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_V, Event.CTRL_MASK));
		//pasteItem.setMnemonic((int)'P');
	    editMenu.add(undoItem);
        editMenu.add(JSeparator9);
        
		//editMenu - cutItem
		cutItem.setIcon(cutIcon);
		cutItem.setActionCommand("Cut");
		//cutItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_X, Event.CTRL_MASK));
		//cutItem.setMnemonic((int)'T');
		editMenu.add(cutItem);
		editMenu.add(JSeparator10);
		
		//editMenu - copyItem
		copyItem.setIcon(copyIcon);
		copyItem.setActionCommand("Copy");
		//copyItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_C, Event.CTRL_MASK));
		//copyItem.setMnemonic((int)'C');
		editMenu.add(copyItem);
		editMenu.add(JSeparator11);
		
		////editMenu - pasteItem
		pasteItem.setIcon(pasteIcon);
		pasteItem.setActionCommand("Paste");
		//pasteItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_V, Event.CTRL_MASK));
		//pasteItem.setMnemonic((int)'P');
	    editMenu.add(pasteItem);
        editMenu.add(JSeparator12);
        
		////editMenu - deleteItem
		deleteItem.setIcon(deleteIcon);
		deleteItem.setActionCommand("Delete");
		//pasteItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_V, Event.CTRL_MASK));
		//pasteItem.setMnemonic((int)'P');
	    editMenu.add(deleteItem);
        editMenu.add(JSeparator13);
        
		////editMenu - selectAllItem
		selectAllItem.setIcon(selectAllIcon);
		selectAllItem.setActionCommand("SelectAll");
		//pasteItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_V, Event.CTRL_MASK));
		//pasteItem.setMnemonic((int)'P');
	    editMenu.add(selectAllItem);


	    
	    
	    
	    JMenu menusInWordsMenu = new JMenu();
          //menusInWordsItem.setIcon(menusInWordsIcon);
        //ImageIcon menusInWordsIcon = new ImageIcon("images/630/48.MENUWORDS.ASL1.gif");
        //menusInWordsMenu.setIcon(menusInWordsIcon);
        //need a flag submenu to put on menusInWordsItem
 	    JMenu countryFlagMenu4 = new JMenu();
        
        //this is the menus menu - keep this just after editMenu for room
	    JMenu menusMenu1 = new JMenu();
	    menusMenu1.setIcon(menusIcon);
	    //menusMenu1.setText(messages.getString("menusMenuTitle"));//"Menus");
		menusMenu1.setMnemonic((int)'3');//'M');
         menusMenu1.add(menusInIconsItem);
         menusMenu1.add(JSeparator14);
	     menusMenu1.add(menusInSignsMenu);//.add(menusInSignsItem);
	     menusMenu1.add(JSeparator17);
         menusMenu1.add(menusInWordsMenu);
	     menusMenu1.add(JSeparator15);
	     menusMenu1.add(menusInSignsAndWordsMenu);//.add(menusInSignsItem);
	     menusMenu1.add(JSeparator16);
	     //menusMenu1.add(menusInSignsAndWordsItem);
	     menusMenu1.add(menusInIconsAndWordsItem);
	     menusMenu1.add(JSeparator18);
	     menusMenu1.add(menusInSignsAndIconsItem);
	     menusMenu1.add(JSeparator19);
	     menusMenu1.add(menusInColorItem);

//*****************************************************************
//*** create menuItems and load with info from messagesBundle ***//
//***
		SymAction lSymAction = new SymAction();
           
        String img;
        String icon;
        String itemIntegerSpacing;
        String imgx = "";

        imgDisplay = new JTextArea();
        //getContentPane().add(imgDisplay);
		imgDisplay.setBounds(62,517,377,24);

        Vector menuItems = new Vector(51);

        //create some menus
 	    JMenu fingerspellingMenu = new JMenu();
 	    JMenu typeWordsMenu = new JMenu();
 	    JMenu dictionariesMenu = new JMenu();
        
        //create the menuItems arrays
        jx = new JMenuItem[51];
        separatorArray = new JSeparator[51];
        separatorArray3 = new JSeparator[51];
        separatorArray2 = new JSeparator[51];
        separatorArray1 = new JSeparator[51];

        //typeFingerspellingWordsMenu1Items = new JMenuItem[51];
        fingerspellingMenuItems = new JMenuItem[51];
        
        //typeWordsWordsmenu1Items = new JMenuItem[51];
        typeWordsMenuItems = new JMenuItem[51];
        
        //signDictionariesWordsMenu1Items = new JMenuItem[51];
        dictionariesMenuItems = new JMenuItem[51];

        //
        //
           //make ImageIcon arrays
           imageIcon1 = new ImageIcon[51];
           imageIcon2 = new ImageIcon[51];
           imageIcon3 = new ImageIcon[51];
           imageIcon4 = new ImageIcon[51];
           for(int k = 1; k < 51; k++)
           {
              //create strings to use in retreiving info from messagesBundle
              country = "country" + Integer.toString(k);
              img = "ASLimage" + Integer.toString(k);
              icon = "image" + Integer.toString(k) + "Icon";
              imageIcon1[k] = new ImageIcon(setupMessages.getString(img));
	          //jx[k] = new JMenuItem(setupMessages.getString(country),imageIcon1[k]);
	          jx[k] = new JMenuItem(imageIcon1[k]);
                 separatorArray[k] = new JSeparator();
                 separatorArray3[k] = new JSeparator();
                 separatorArray2[k] = new JSeparator();
                 separatorArray1[k] = new JSeparator();
              //typeFingerspellingWordsMenu1Items = new JMenuItem[51];
              imageIcon2[k] = new ImageIcon(setupMessages.getString(img));
              //fingerspellingMenuItems[k] = new JMenuItem(setupMessages.getString(country),imageIcon2[k]);
              fingerspellingMenuItems[k] = new JMenuItem(imageIcon2[k]);
              //typeWordsWordsmenu1Items = new JMenuItem[51];
              imageIcon3[k] = new ImageIcon(setupMessages.getString(img));
              //typeWordsMenuItems[k] = new JMenuItem(setupMessages.getString(country),imageIcon3[k]);
              typeWordsMenuItems[k] = new JMenuItem(imageIcon3[k]);
              //signDictionariesWordsMenu1Items = new JMenuItem[51];
              imageIcon4[k] = new ImageIcon(setupMessages.getString(img));
              //dictionariesMenuItems[k] = new JMenuItem(setupMessages.getString(country),imageIcon4[k]);
              dictionariesMenuItems[k] = new JMenuItem(imageIcon4[k]);
              //
                 
    //But if MessagesBundle_language_country.properties
		        String languageK = "code"  + "l" + Integer.toString(k);
		        String countryK = "code"  + "c" + Integer.toString(k);

                String checkFileExists = "MessagesBundle_" + (setupMessages.getString(languageK )) + "_" + (setupMessages.getString(countryK)) + ".properties";
                File f = new File( checkFileExists );
		    

                //****** for debugging
                if(!( f.exists()))
                {
                    flg[k] = false;
                    displayProblem(k);
                    checkFileExists += "DOES NOT EXIST";
                    imgDisplay.append(checkFileExists);
                }
                //********************
                

	          if(flg[k] == true)
	          {
	            menusInWordsMenu.add(jx[k]);
	            menusInWordsMenu.add(separatorArray[k]);
	            
	            fingerspellingMenu.add(fingerspellingMenuItems[k]);
	            fingerspellingMenu.add(separatorArray2[k]);
	            
	            typeWordsMenu.add(typeWordsMenuItems[k]);
	            typeWordsMenu.add(separatorArray3[k]);
	            
	            dictionariesMenu.add(dictionariesMenuItems[k]);
	            dictionariesMenu.add(separatorArray1[k]);
	          }
	          jx[k].addActionListener(lSymAction);
	          jx[k].setHorizontalTextPosition(SwingConstants.RIGHT);
	          
	          fingerspellingMenuItems[k].addActionListener(lSymAction);
	          fingerspellingMenuItems[k].setHorizontalTextPosition(SwingConstants.RIGHT);
	          
	          typeWordsMenuItems[k].addActionListener(lSymAction);
	          typeWordsMenuItems[k].setHorizontalTextPosition(SwingConstants.RIGHT);
	          
	          dictionariesMenuItems[k].addActionListener(lSymAction);
	          dictionariesMenuItems[k].setHorizontalTextPosition(SwingConstants.RIGHT);
	          
           }

		//add it to the menuBar
		JMenuBar1.add(menusMenu1);


    //declare the ImageIcons    
    ImageIcon usaFlagIcon   = new ImageIcon("images/41._USA_in_ASL.gif");
    ImageIcon usaFlagIcon2  = new ImageIcon("images/41._USA_in_ASL.gif");

    ImageIcon menusInIconsIcon          = new ImageIcon(messages.getString("menusMenuItemMenusinIcons"));//("images/630/46.MENUICONS.ASL1.gif");
    ImageIcon menusInSignsIcon          = new ImageIcon(messages.getString("menusMenuItemMenusinSigns"));//("images/630/47.MENUSIGNS.ASL1.gif");
    ImageIcon menusInWordsIcon          = new ImageIcon(messages.getString("menusMenuItemMenusinWords"));//("images/630/48.MENUWORDS.ASL1.gif");
    ImageIcon menusInIconsAndWordsIcon  = new ImageIcon(messages.getString("menusMenuItemMenusinIcons&Words"));//("images/630/50.MENUICONSWORDS.ASL1.gif");
    ImageIcon menusInSignsAndWordsIcon  = new ImageIcon(messages.getString("menusMenuItemMenusinSigns&Words"));//("images/630/49.MENUSIGNSWORDS.ASL1.gif");
    ImageIcon menusInSignsAndIconsIcon  = new ImageIcon(messages.getString("menusMenuItemMenusinSigns&Icons"));//("images/630/51.MENUSIGNSICONS.ASL1.gif");
    ImageIcon menusInColorIcon          = new ImageIcon(messages.getString("menusMenuItemMenusinColor"));//("images/630/52.MENUCOLOR.ASL1.gif");
  


        menusInIconsItem.setIcon(menusInIconsIcon);
        menusInIconsItem.addActionListener(lSymAction);

        //menusInSignsMenu
	    menusInSignsMenu.setIcon(menusInSignsIcon);
         //usaSignsItem.setText("zzzUSA");// - ASL");  
		 usaSignsItem.setHorizontalTextPosition(SwingConstants.RIGHT);
         usaSignsItem.setIcon(usaFlagIcon);// - ASL");   
         usaSignsItem.addActionListener(lSymAction);
        menusInSignsMenu.add(usaSignsItem);
        
        //menusInWordsMenu
        menusInWordsMenu.setIcon(menusInWordsIcon);

        //menusInSignsAndWordsMenu
        menusInSignsAndWordsMenu.setIcon(menusInSignsAndWordsIcon);
        
		 usaSignsItem2.setHorizontalTextPosition(SwingConstants.RIGHT);
         usaSignsItem2.setIcon(usaFlagIcon);
         usaSignsItem2.addActionListener(lSymAction);
        menusInSignsAndWordsMenu.add(usaSignsItem2);
        
        
        menusInIconsAndWordsItem.setIcon(menusInIconsAndWordsIcon);
        menusInSignsAndIconsItem.setIcon(menusInSignsAndIconsIcon);
        menusInColorItem.setIcon(menusInColorIcon);
	
	    //typeSigns menu
	    JMenu typeSignsMenu1 = new JMenu();
		typeSignsMenu1.setIcon(signsIcon);
		typeSignsMenu1.setMnemonic((int)'4');//'S');

		//typeSignsMenu1 - signsMenuItemDownColL-R
		signsMenuItemDownColLR.setIcon(signsMenuItemDownColLRIcon);
        signsMenuItemDownColRL.setIcon(signsMenuItemDownColRLIcon);
        signsMenuItemAcrossLR.setIcon(signsMenuItemAcrossLRIcon);
        signsMenuItemAcrossRL.setIcon(signsMenuItemAcrossRLIcon);
        signsMenuItemOtherPatterns.setIcon(signsMenuItemOtherPatternsIcon);
        
		//typeSignsMenu1
		typeSignsMenu1.add(signsMenuItemDownColLR);
        typeSignsMenu1.add(JSeparator20);
        typeSignsMenu1.add(signsMenuItemDownColRL);
        typeSignsMenu1.add(JSeparator21);
        typeSignsMenu1.add(signsMenuItemAcrossLR);
        typeSignsMenu1.add(JSeparator22);
        typeSignsMenu1.add(signsMenuItemAcrossRL);
        typeSignsMenu1.add(JSeparator23);
        typeSignsMenu1.add(signsMenuItemOtherPatterns);
        JMenuBar1.add(typeSignsMenu1);
 
        //fingerspellingMenu
        fingerspellingMenu.setIcon(fingerspellingIcon);
		fingerspellingMenu.setMnemonic((int)'5');//'G');
		JMenuBar1.add(fingerspellingMenu);
	    
	    //typeWordsMenu 
		typeWordsMenu.setIcon(typeWordsIcon);
		typeWordsMenu.setMnemonic((int)'6');//'W');
		JMenuBar1.add(typeWordsMenu);
        
        //dictionaries Menu
		dictionariesMenu.setIcon(dictionariesIcon);
		dictionariesMenu.setMnemonic((int)'7');//'D');
		JMenuBar1.add(dictionariesMenu);
        
        //fonts Menu
	    JMenu fontsMenu1 = new JMenu();
		fontsMenu1.setIcon(fontsIcon);
		fontsMenu1.setMnemonic((int)'8');//'T');
        
        largeFontsItem.setIcon(largeFontsIcon);
        fontsMenu1.add(largeFontsItem);
	    fontsMenu1.add(JSeparator24);
	    
	    mediumFontsItem.setIcon(mediumFontsIcon);
	    fontsMenu1.add(mediumFontsItem);
	    fontsMenu1.add(JSeparator25);
	    
	    smallFontsItem.setIcon(smallFontsIcon);
	    fontsMenu1.add(smallFontsItem);
        fontsMenu1.add(JSeparator26);
	    
	    italicFontsItem.setIcon(italicFontsIcon);
	    fontsMenu1.add(italicFontsItem);
	    fontsMenu1.add(JSeparator27);
	    
	    boldFontsItem.setIcon(boldFontsIcon);
	    fontsMenu1.add(boldFontsItem);
	    fontsMenu1.add(JSeparator28);
	    
	    colorSymbolsFontsItem.setIcon(colorSymbolsFontsIcon);
	    fontsMenu1.add(colorSymbolsFontsItem);
		
		JMenuBar1.add(fontsMenu1);
        
		// helpMenu
		helpMenu.setIcon(helpIcon);
		helpMenu.setActionCommand("Help");
		helpMenu.setMnemonic((int)'9');//'H');
		JMenuBar1.add(helpMenu);
		lessonsInSignWritingItem.setIcon(lessonsInSignWritingIcon);
		lessonsInSignWriterItem.setIcon(lessonsInSignWriterIcon);
		aboutSignWriterItem.setIcon(aboutSignWriterIcon);
		technicalSupportItem.setIcon(technicalSupportIcon);
		//
		aboutSignWriterItem.setMnemonic((int)'A');
		helpMenu.add(lessonsInSignWritingItem);
		helpMenu.add(JSeparator29);
		helpMenu.add(lessonsInSignWriterItem);
		helpMenu.add(JSeparator30);
		helpMenu.add(aboutSignWriterItem);
		helpMenu.add(JSeparator31);
		helpMenu.add(technicalSupportItem);
		

		//{{REGISTER_LISTENERS
		SymMouse aSymMouse = new SymMouse();
		goToConfigButton.addMouseListener(aSymMouse);
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		//SymAction lSymAction = new SymAction();
		openItem.addActionListener(lSymAction);
		saveItem.addActionListener(lSymAction);
		exitItem.addActionListener(lSymAction);
		aboutSignWriterItem.addActionListener(lSymAction);
		openButton.addActionListener(lSymAction);
		saveButton.addActionListener(lSymAction);
		aboutButton.addActionListener(lSymAction);
		menusInWordsItem.addActionListener(lSymAction);


		
		
    this.setVisible(true);
		
};

	/**
	 * The entry point for this application.
	 * Sets the Look and Feel to the System Look and Feel.
	 * Creates a new JFrame1 and makes it visible.
	 */
//&&&&&&&&&
	static public void main(String args[])
	{
		try {
		    // Add the following code if you want the Look and Feel
		    // to be set to the Look and Feel of the native system.
		    //try {
		    //    UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		    //} 
		    //catch (Exception e) { 
		    //}

			//Create a new instance of our application's frame, and make it visible.
			//*******new IntlIconMenus1a(flg).setVisible(true);
		} 
		catch (Throwable t) {
			t.printStackTrace();
			//Ensure the application exits with an error condition.
			System.exit(1);
		}
	}//main

    /**
     * Notifies this component that it has been added to a container
     * This method should be called by <code>Container.add</code>, and 
     * not by user code directly.
     * Overridden here to adjust the size of the frame if needed.
     * @see java.awt.Container#removeNotify
     */
	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
		Dimension size = getSize();
		
		super.addNotify();
		
		if (frameSizeAdjusted)
			return;
		frameSizeAdjusted = true;
		
		// Adjust size of frame according to the insets and menu bar
		JMenuBar menuBar = getRootPane().getJMenuBar();
		int menuBarHeight = 0;
		if (menuBar != null)
		    menuBarHeight = menuBar.getPreferredSize().height;
		Insets insets = getInsets();
		setSize(insets.left + insets.right + size.width, insets.top + insets.bottom + size.height + menuBarHeight);
	}//method

	// Used by addNotify
	boolean frameSizeAdjusted = false;

    //
	FileDialog saveFileDialog = new FileDialog(this);
	FileDialog openFileDialog = new FileDialog(this);
	
	JPanel JPanel2 = new JPanel();
	JToolBar JToolBar1 = new JToolBar();
	
	JButton goToConfigButton = new JButton();
	JButton newButton = new JButton();
	JButton openButton = new JButton();
	JButton saveButton = new JButton();
	JButton cutButton = new JButton();
	JButton copyButton = new JButton();
	JButton pasteButton = new JButton();
	JButton aboutButton = new JButton();
	
	JPanel JPanel1 = new JPanel();
	
	JMenuBar JMenuBar1 = new JMenuBar();
	JMenu fileMenu = new JMenu();
	 JMenuItem newItem = new JMenuItem();
	 JMenuItem openItem = new JMenuItem();
	 JMenuItem saveItem = new JMenuItem();
	 JMenuItem saveAsItem = new JMenuItem();
	 JMenuItem printItem = new JMenuItem();
     JMenuItem exitItem = new JMenuItem();
     
	JSeparator JSeparator1 = new JSeparator();
	JSeparator JSeparator2 = new JSeparator();
	JSeparator JSeparator3 = new JSeparator();
	JSeparator JSeparator4 = new JSeparator();
	JSeparator JSeparator5 = new JSeparator();
	JSeparator JSeparator6 = new JSeparator();
	JSeparator JSeparator7 = new JSeparator();
	JSeparator JSeparator8 = new JSeparator();
	JSeparator JSeparator9 = new JSeparator();
	JSeparator JSeparator10 = new JSeparator();
	JSeparator JSeparator11 = new JSeparator();
	JSeparator JSeparator12 = new JSeparator();
	JSeparator JSeparator13 = new JSeparator();
	JSeparator JSeparator14 = new JSeparator();
	JSeparator JSeparator15 = new JSeparator();
	JSeparator JSeparator16 = new JSeparator();
	JSeparator JSeparator17 = new JSeparator();
	JSeparator JSeparator18 = new JSeparator();
	JSeparator JSeparator19 = new JSeparator();
	JSeparator JSeparator20 = new JSeparator();
	JSeparator JSeparator21 = new JSeparator();
	JSeparator JSeparator22 = new JSeparator();
	JSeparator JSeparator23 = new JSeparator();
	JSeparator JSeparator24 = new JSeparator();
	JSeparator JSeparator25 = new JSeparator();
	JSeparator JSeparator26 = new JSeparator();
	JSeparator JSeparator27 = new JSeparator();
	JSeparator JSeparator28 = new JSeparator();
	JSeparator JSeparator29 = new JSeparator();
	JSeparator JSeparator30 = new JSeparator();
	JSeparator JSeparator31 = new JSeparator();
	JSeparator JSeparator32 = new JSeparator();
	JSeparator JSeparator33 = new JSeparator();
	JSeparator JSeparator34 = new JSeparator();
	JSeparator JSeparator35 = new JSeparator();
	JSeparator JSeparator36 = new JSeparator();
	JSeparator JSeparator37 = new JSeparator();
	JSeparator JSeparator38 = new JSeparator();
	JSeparator JSeparator39 = new JSeparator();
	JSeparator JSeparator41 = new JSeparator();
	JSeparator JSeparator42 = new JSeparator();
	JSeparator JSeparator43 = new JSeparator();
	JSeparator JSeparator44 = new JSeparator();
	JSeparator JSeparator45 = new JSeparator();
	JSeparator JSeparator46 = new JSeparator();
	JSeparator JSeparator47 = new JSeparator();
	JSeparator JSeparator48 = new JSeparator();
	JSeparator JSeparator49 = new JSeparator();
	JSeparator JSeparator50 = new JSeparator();
	
	JMenu editMenu = new JMenu();
	 JMenuItem undoItem = new JMenuItem();
	 JMenuItem cutItem = new JMenuItem();
	 JMenuItem copyItem = new JMenuItem();
	 JMenuItem pasteItem = new JMenuItem();
	 JMenuItem deleteItem = new JMenuItem();
	 JMenuItem selectAllItem = new JMenuItem();
	
	//help menu and help menu items
	JMenu helpMenu = new JMenu();
	 JMenuItem lessonsInSignWritingItem = new JMenuItem();
	 JMenuItem lessonsInSignWriterItem = new JMenuItem();
	 JMenuItem aboutSignWriterItem = new JMenuItem();
	 JMenuItem technicalSupportItem = new JMenuItem();

    // menusInSignsAndIconsItem   
	JMenuItem menusInIconsItem = new JMenuItem();
    JMenu menusInSignsMenu = new JMenu();
    JMenu menusInSignsAndWordsMenu = new JMenu();

	JMenuItem menusInSignsItem = new JMenuItem();
	JMenuItem usaSignsItem = new JMenuItem();
	JMenuItem usaSignsItem2 = new JMenuItem();
	JMenuItem usaSignsItem3 = new JMenuItem();
	
	JMenuItem menusInWordsItem = new JMenuItem();
	JMenuItem menusInSignsAndWordsItem = new JMenuItem();
	JMenuItem menusInIconsAndWordsItem = new JMenuItem();
	JMenuItem menusInSignsAndIconsItem = new JMenuItem();
	JMenuItem menusInColorItem = new JMenuItem();
    //
	JMenuItem signsMenuItemDownColLR = new JMenuItem();
	JMenuItem signsMenuItemDownColRL = new JMenuItem();
	JMenuItem signsMenuItemAcrossLR = new JMenuItem();
	JMenuItem signsMenuItemAcrossRL = new JMenuItem();
	JMenuItem signsMenuItemOtherPatterns = new JMenuItem();

    //items for fonts menu
    JMenuItem largeFontsItem = new JMenuItem();
    JMenuItem mediumFontsItem = new JMenuItem();
    JMenuItem smallFontsItem = new JMenuItem();
    JMenuItem boldFontsItem = new JMenuItem();
    JMenuItem italicFontsItem = new JMenuItem();
    JMenuItem colorSymbolsFontsItem = new JMenuItem();

    JMenu menusInASLSignsMenu = new JMenu();
    JMenuItem menusInASLSigns1aMenuItem = new JMenuItem();
    //
	//JMenu countryFlagMenu = new JMenu();
	JMenu fingerspellingMenu = new JMenu();
	//JMenu typeWordsMenu = new JMenu();
	//}}

	void exitApplication()
	{
		try {
	    	// Beep
	    	Toolkit.getDefaultToolkit().beep();
	    	// Show a confirmation dialog
	    	int reply = JOptionPane.showConfirmDialog(this, 
	    	                                          "Do you really want to exit?", 
	    	                                          "         SignWriter 5.0 - Exit" , 
	    	                                          JOptionPane.YES_NO_OPTION, 
	    	                                          JOptionPane.QUESTION_MESSAGE);
			// If the confirmation was affirmative, handle exiting.
			if (reply == JOptionPane.YES_OPTION)
			{
		    	this.setVisible(false);    // hide the Frame
		    	this.dispose();            // free the system resources
		    	System.exit(0);            // close the application
			}
		} catch (Exception e) {}
	}//method
	

	class SymMouse extends MouseAdapter
	{
		public void mouseReleased(MouseEvent event)
		{
			Object object = event.getSource();
			if (object == goToConfigButton)
				goToConfigButton_MouseReleased(event);
		}
	}//class

	void goToConfigButton_MouseReleased(MouseEvent event)
	{
		// to do: code goes here.
			 
		goToConfigButton_MouseReleased_Interaction1(event);
	}//method

	void goToConfigButton_MouseReleased_Interaction1(MouseEvent event)
	{
		try {
			this.removeAll();
			new After1stTimeSetup(flg).setVisible(true);
			this.dispose();
		} catch (Exception e) {
		}
	}//method
//}
	

	class SymWindow extends WindowAdapter
	{
		public void windowClosing(WindowEvent event)
		{
			Object object = event.getSource();
			if (object == MenusInASLSigns1a.this)
				MenusInASLSigns1a_windowClosing(event);
		}
	}//class

	void MenusInASLSigns1a_windowClosing(WindowEvent event)
	{
		// to do: code goes here.
			 
		MenusInASLSigns1a_windowClosing_Interaction1(event);
	}

	void MenusInASLSigns1a_windowClosing_Interaction1(WindowEvent event) {
		try {
			this.exitApplication();
		} catch (Exception e) {
		}
	}

	class SymAction implements ActionListener
	{
		public void actionPerformed(ActionEvent event)
		{
			Object object = event.getSource();
			for(int ii = 1; ii < 51; ii++)
			{
			    if (object == jx[ii])//jx is a menu item
			    {
			        //save the index of the country menuItem that was chosen
			        saveJxxx = ii;
			        //call the method to deal with the choice
			        jx_actionPerformed(event);
                }			    
			}
			if (object == openItem)
				openItem_actionPerformed(event);
			else if (object == saveItem)
				saveItem_actionPerformed(event);
			else if (object == exitItem)
				exitItem_actionPerformed(event);
			else if (object == aboutSignWriterItem)
				aboutItem_actionPerformed(event);
			else if (object == openButton)
				openButton_actionPerformed(event);
			else if (object == saveButton)
				saveButton_actionPerformed(event);
			else if (object == aboutButton)
				aboutButton_actionPerformed(event);
			else if (object == menusInASLSigns1aMenuItem)
				menusInASLSigns1aMenuItem_actionPerformed(event);
			else if (object == usaSignsItem)
				usaSignsItem_actionPerformed(event);
			else if (object == usaSignsItem2)
				usaSignsItem2_actionPerformed(event);
			else if (object == menusInIconsItem)
				menusInIconsItem_actionPerformed(event);
		}
	}

	void jx_actionPerformed(ActionEvent event)
	{

                    this.removeAll();
                    //this.setVisible(false);
                    new IntlWordsMenus1a(flg, saveJxxx);
                    this.dispose();
	}
	
	void usaSignsItem_actionPerformed(ActionEvent event)
	{
	    this.removeAll();
	    new MenusInASLSigns1a(flg);
	    this.dispose();
	}
	void usaSignsItem2_actionPerformed(ActionEvent event)
	{
	    this.removeAll();
	    new MenusInASLSignsAndWords1a(flg);
	    this.dispose();
	}
	
	void menusInASLSigns1aMenuItem_actionPerformed(ActionEvent event)
	{
	    this.removeAll();
	    new MenusInASLSigns1a(flg);
	    this.dispose();
	}
	void menusInIconsItem_actionPerformed(ActionEvent event)
	{
	    this.removeAll();
	    new IntlIconMenus1a(flg);//(MenusInASLSigns1a.flg);
	    this.dispose();
	}

	void openItem_actionPerformed(ActionEvent event)
	{
		// to do: code goes here.
			 
		openItem_actionPerformed_Interaction1(event);
	}

	void openItem_actionPerformed_Interaction1(ActionEvent event) {
		try {
			// openFileDialog Show the FileDialog
			openFileDialog.setVisible(true);
		} catch (Exception e) {
		}
	}

	void saveItem_actionPerformed(ActionEvent event)
	{
		// to do: code goes here.
			 
		saveItem_actionPerformed_Interaction1(event);
	}

	void saveItem_actionPerformed_Interaction1(ActionEvent event) {
		try {
			// saveFileDialog Show the FileDialog
			saveFileDialog.setVisible(true);
		} catch (Exception e) {
		}
	}

	void exitItem_actionPerformed(ActionEvent event)
	{
		// to do: code goes here.
			 
		exitItem_actionPerformed_Interaction1(event);
	}

	void exitItem_actionPerformed_Interaction1(ActionEvent event) {
		try {
			this.exitApplication();
		} catch (Exception e) {
		}
	}

	void aboutItem_actionPerformed(ActionEvent event)
	{
		// to do: code goes here.
			 
		aboutItem_actionPerformed_Interaction1(event);
	}

	void aboutItem_actionPerformed_Interaction1(ActionEvent event) {
		try {
			// JAboutDialog Create with owner and show as modal
			{
				JAboutDialog JAboutDialog1 = new JAboutDialog(this);
				JAboutDialog1.setModal(true);
				JAboutDialog1.show();
			}
		} catch (Exception e) {
		}
	}

	void openButton_actionPerformed(ActionEvent event)
	{
		// to do: code goes here.
			 
		openButton_actionPerformed_Interaction1(event);
	}

	void openButton_actionPerformed_Interaction1(ActionEvent event) {
		try {
			// openFileDialog Show the FileDialog
			openFileDialog.setVisible(true);
		} catch (Exception e) {
		}
	}

	void saveButton_actionPerformed(ActionEvent event)
	{
		// to do: code goes here.
			 
		saveButton_actionPerformed_Interaction1(event);
	}

	void saveButton_actionPerformed_Interaction1(ActionEvent event) {
		try {
			// saveFileDialog Show the FileDialog
			saveFileDialog.setVisible(true);
		} catch (Exception e) {
		}
	}

	void aboutButton_actionPerformed(ActionEvent event)
	{
		// to do: code goes here.
			 
		aboutButton_actionPerformed_Interaction1(event);
	}
	//


    //
    void displayProblem(int k)
    {
	    Locale setupLocaleK = new Locale("Checkbox", "Countries");
	    ResourceBundle setupMessagesK = ResourceBundle.getBundle("MessagesBundle", setupLocaleK);
		        String languageK = "code"  + "l" + Integer.toString(k);
		        String countryK = "code"  + "c" + Integer.toString(k);


        String checkFileExists = "MessagesBundle_" + (setupMessagesK.getString(languageK )) + "_" + (setupMessagesK.getString(countryK)) + ".properties";
        checkFileExists += "DOES NOT EXIST";
        imgDisplay.append(checkFileExists);
        //.setText(checkFileExists);// + "DOES NOT XXX EXIST");
    }
	//
	void aboutButton_actionPerformed_Interaction1(ActionEvent event) {
		try {
			// JAboutDialog Create with owner and show as modal
			{
				JAboutDialog JAboutDialog1 = new JAboutDialog(this);
				JAboutDialog1.setModal(true);
				JAboutDialog1.show();
			}
		} catch (Exception e) {
		}
	}
}
